/* -*- Mode: C -*-
 *
 * File: mootdump_cmdparser.h
 * Description: Headers for command-line parser struct gengetopt_args_info.
 *
 * File autogenerated by optgen.perl version 0.07.
 *
 */

#ifndef mootdump_cmdparser_h
#define mootdump_cmdparser_h

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*
 * moocow: Never set PACKAGE and VERSION here.
 */

struct gengetopt_args_info {
  char * rcfile_arg;	 /* Read an alternate configuration file. (default=NULL). */
  int verbose_arg;	 /* Verbosity level. (default=3). */
  int no_banner_flag;	 /* Suppress initial banner message (implied at verbosity levels <= 2) (default=0). */
  int hash_ngrams_arg;	 /* Whether to hash stored n-grams (default=yes) (default=1). */
  int const_flag;	 /* Enable dump of scalar model constants (default=0). */
  int lex_flag;	 /* Enable lexical probability dump (default=0). */
  int class_flag;	 /* Enable lexical-class probability dump (default=0). */
  int suffix_flag;	 /* Enable suffix-trie dump (default=0). */
  int ngrams_flag;	 /* Enable tag n-gram probability dump (default=0). */
  char * output_arg;	 /* Specify output file (default=stdout). (default=-). */

  int help_given;	 /* Whether help was given */
  int version_given;	 /* Whether version was given */
  int rcfile_given;	 /* Whether rcfile was given */
  int verbose_given;	 /* Whether verbose was given */
  int no_banner_given;	 /* Whether no-banner was given */
  int hash_ngrams_given;	 /* Whether hash-ngrams was given */
  int const_given;	 /* Whether const was given */
  int lex_given;	 /* Whether lex was given */
  int class_given;	 /* Whether class was given */
  int suffix_given;	 /* Whether suffix was given */
  int ngrams_given;	 /* Whether ngrams was given */
  int output_given;	 /* Whether output was given */
  
  char **inputs;         /* unnamed arguments */
  unsigned inputs_num;   /* number of unnamed arguments */
};

/* read rc files (if any) and parse all command-line options in one swell foop */
int  cmdline_parser (int argc, char *const *argv, struct gengetopt_args_info *args_info);

/* instantiate defaults from environment variables: you must call this yourself! */
void cmdline_parser_envdefaults (struct gengetopt_args_info *args_info);

/* read a single rc-file */
void cmdline_parser_read_rcfile (const char *filename,
				    struct gengetopt_args_info *args_info,
				    int user_specified);

/* read a single rc-file (stream) */
void cmdline_parser_read_rc_stream (FILE *rcfile,
				       const char *filename,
				       struct gengetopt_args_info *args_info);

/* parse a single option */
int cmdline_parser_parse_option (char oshort, const char *olong, const char *val,
				    struct gengetopt_args_info *args_info);

/* print help message */
void cmdline_parser_print_help(void);

/* print version */
void cmdline_parser_print_version(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* mootdump_cmdparser_h */
